#include <stdio.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>

#ifdef FAN
char *read_fan()
{
	FILE *f;
	int d;
	char *buffer;


	buffer = malloc(sizeof(char)*512);
	if ((f = fopen("/proc/acpi/ibm/fan", "r")) == NULL) {
		sprintf(buffer, "ibm-acpi?");
		return(buffer);
	}
	fgets(buffer, 512, f);
	fgets(buffer, 512, f);
	sscanf(buffer, "speed: %d", &d);
	if (d == 0) {
		snprintf(buffer, 512, "FAN off");
	}
	else {
		snprintf(buffer, 512, "FAN %d", d);
	}
	fclose(f);

	//printf("buffer=%s\n", buffer);

	return(buffer);
}
#endif

#ifdef THERMAL
char *read_data(int i)
{
	FILE *f;
	int d[8]; 
	char *buffer;


	buffer = malloc(sizeof(char)*512);
	if ((f = fopen("/proc/acpi/ibm/thermal", "r")) == NULL) {
		sprintf(buffer, "ibm-acpi?");
		return(buffer);
	}
	fgets(buffer, 512, f);
	sscanf(buffer, "temperatures: %d %d %d %d %d %d %d %d", &d[0], &d[1], &d[2], &d[3], &d[4], &d[5], &d[6], &d[7]);
	switch (i) {
	case 0:
		snprintf(buffer, 512, "CPU %dC", d[i]);
		break;
	case 1:
		snprintf(buffer, 512, "PCI %dC", d[i]);
		break;
	case 2:
		snprintf(buffer, 512, "HDD %dC", d[i]);
		break;
	case 3:
		snprintf(buffer, 512, "GPU %dC", d[i]);
		break;
	case 4:
		if (d[i] < 0) snprintf(buffer, 512, "BAT n/a");
		else snprintf(buffer, 512, "BAT %dC", d[i]);
		break;
	}
	fclose(f);
 
	//printf("buffer=%s\n", buffer);
 
	return(buffer);
}
#endif
